import urllib.request, urllib.error, urllib.parse, json, pprint

api_url = "https://api.radb.net/api/radb/"
mnt_pw = "password=MyPlaintextMntnerPassWrd"
api_auth = 'Basic XYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZ=='
hdrs_ptxt = {'accept': 'text/plain', 'Authorization': api_auth}
hdrs_json = {'accept': 'application/json', 'Authorization': api_auth}

def radb_api_req(req_url, req_hdrs, req_data):
	req_req = urllib.request.Request(req_url, req_data, req_hdrs)
	return urllib.request.urlopen(req_req).read()

print('\n GET object plain text example: \n')
get_obj_ptxt = radb_api_req(api_url + "mntner/MAINT-AS64505?" + mnt_pw, hdrs_ptxt, None)
print(get_obj_ptxt.decode())

print('\n GET object json example: \n')
get_obj_json = radb_api_req(api_url + "mntner/MAINT-AS64505?" + mnt_pw, hdrs_json, None)
print(get_obj_json.decode())

print('\n GET search plain text example: \n')
get_search_ptxt = radb_api_req(api_url + "search?query-string=MAINT-AS64505&inverse-attribute=mnt-by&" + mnt_pw, hdrs_ptxt, None)
print(get_search_ptxt.decode())

print('\n GET search json example: \n')
get_search_json = radb_api_req(api_url + "search?query-string=MAINT-AS64505&inverse-attribute=mnt-by&" + mnt_pw, hdrs_json, None)
print(get_search_json.decode())

print('\n POST add new objects: \n')
req_url = api_url + "aut-num?" + mnt_pw
req_data = """
aut-num:    AS64505
as-name:    ASTEST64505
descr:      Testing RADb API for documentation
admin-c:    Me Myself I
tech-c:     Someone else
notify:     someone@example.com
mnt-by:     MAINT-AS64505
changed:    someone@example.com 20190801
source:     RADB
"""
req_data = req_data.encode()
post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
pprint.pprint(post_obj.decode())

print('\n Update existing objects: \n')
req_url = api_url + "aut-num?" + mnt_pw
req_data = """
aut-num:    AS64505
as-name:    ASTEST64505
descr:      UPDATED Testing RADb API for documentation
admin-c:    Me Myself I
tech-c:     Someone else
notify:     someone@example.com
mnt-by:     MAINT-AS64505
changed:    someone@example.com 20190801
source:     RADB
"""
req_data = req_data.encode()
post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
pprint.pprint(post_obj.decode())

print('\n Delete existing objects: \n')
req_url = api_url + "aut-num?" + mnt_pw
req_data = """
aut-num:    AS64505
as-name:    ASTEST64505
descr:      UPDATED Testing RADb API for documentation
admin-c:    Me Myself I
tech-c:     Someone else
notify:     someone@example.com
mnt-by:     MAINT-AS64505
changed:    someone@example.com 20190801
source:     RADB
delete:		contact@example.com deletereason
"""
req_data = req_data.encode()
post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
pprint.pprint(post_obj.decode())
